#---------------------------------------------------------------------------
# This function will read the DBC files
#---------------------------------------------------------------------------
sub readDBCFile
#---------------------------------------------------------------------------
{
  $readdbc_stime = time;

  $longest = 0;

  $i_hosts = 0;
  $i_users = 0;

  %dbc_parm = (); 

  my @logdetails_dbc = (); 

  my $tuserid = ""; 
  my $tcomm = ""; 

  my $zwork = ""; 
  my $this_counter = ""; 
  my @zwords = (); 

  my $debug_r = 0; 

  undef $num_informix;
  undef $num_oracle;
  undef $num_oracleapps;
  undef $num_oraclent;
  undef $num_sap;
  undef $num_mssql;
  undef $num_unknown;
  undef $num_oswin;
  
  undef $dbtot_informix;
  undef $dbtot_oracle;
  undef $dbtot_oracleapps;
  undef $dbtot_oraclent;
  undef $dbtot_sap;
  undef $dbtot_mssql;
  undef $dbtot_unknown;

  undef $gbtot_informix;
  undef $gbtot_oracle;
  undef $gbtot_oracleapps;
  undef $gbtot_oraclent;
  undef $gbtot_sap;
  undef $gbtot_mssql;
  undef $gbtot_unknown;

  undef %server_events_this_iter;
  $server_wide_events_file = "/opt/dbamon/adm/server_wide_events.txt"; 
  if (-e $server_wide_events_file)
  {
    chop($server_wide_events = uc `cat $server_wide_events_file | grep -v '^#' | awk '{ print \$1 }'`);
    &logit("Server-Wide-Events: $server_wide_events");
  }

  $debug_read = 0;

  &logit("Reading DBC file directory from $parmdir");

  opendir(DBC_DIR, "$parmdir") || &error_msg("Cannot opendir $parmdir - $!");
  @dbc_files = sort readdir DBC_DIR;
  closedir(DBC_DIR);

  &logit("Done reading DBC file directory from $parmdir");

  DBCFILE: foreach $dbc_file (@dbc_files)
  {
    if ($dbc_file =~ /.dbc$/)
    {
      $dbc_count++;

      $zclass = ""; 

      if ($use_dbc_firstchar eq "Y" && $dbamon_alpha ne "")
      {
        $z = uc substr($dbc_file,0,1);      # We will match on the first char of the dbc_file name

        #---- See if DBC_Class: is specified - if so, then it overrides z
        chop($zclass = uc `cat $parmdir/$dbc_file | grep -v '^#' | grep '^DBC_Class:' | awk '{ print \$2 }'`);
        if ($zclass)
        {
          &logit("DEBUG: $parmdir/$dbc_file - Overriding default class of $z with $zclass");
          $z = $zclass;
        }

        if (index($dbamon_alpha,$z) < 0)
        {
          ##print "Skipping $dbc_file - z=$z dbamon_alpha=$dbamon_alpha\n";
          next DBCFILE;
        }
      }

      &logit("Reading DBC file [$i_hosts]: $parmdir/$dbc_file") if $debug_r;
      open(DBC,"$parmdir/$dbc_file");

      #---- 2011/12/16 BB: This seems silly, and expensive
      #---- See if this DBC file has Host: specified twice
      #chop($dupcheck = `cat $parmdir/$dbc_file | grep -v '^#' | grep '^Host:' | wc -l`);
      #if ($dupcheck > 1)
      #{
      #  &logit("**************************************************************************************");
      #  &logit("Host: Specified > once in DBC File: $dbcfilename[$i] - DBC File discarded");
      #  &logit("**************************************************************************************");
      #  next DBCFILE;
      #}

      while (<DBC>)
      {
	&parse;
	next if ($NF == 0);

        if ($F1 eq "Host:")
        {
          ##print "hi ih=$i_hosts \n";

          # z will contain the first letter of the host name. This can 
          # be overridden by first character of DBC
          # file name if Use_DBC_Firstchar: = Y.

          if ($zclass)
          {
            $z = $zclass;
          }
          elsif ($use_dbc_firstchar eq "Y")
          {
            $z = uc substr($dbc_file,0,1);
          }
          else  # We will use first character of hostname
          {
            $z = uc substr($F2,0,1);
          }
          ##print "z=$z dbamon_alpha=$dbamon_alpha F2=$F2 dbc_file=$dbc_file\n";

	  if ((index($dbamon_alpha,$z) > -1 || $dbamon_alpha eq "") && $F3 ne "Inactive") 
	  { 
	    $alpha_flag = 1;
	    ##$msg = sprintf("dbamon_alpha=%s Including Host: %s",$dbamon_alpha,$F2);
	    ##logit($msg);

	    # Increment counter
	    $i_hosts++;

            $dbcfilename[$i_hosts] = "${parmdir}/${dbc_file}";
            $dbcfilenameshort[$i_hosts] = "${dbc_file}";

            #---- 2011/12/16 BB: Turn this off for now. 
            #chop($this_checksum = `cksum $dbcfilename[$i_hosts] | cut -f 1 -d ' '`);
            #if ($this_checksum ne $last_checksum[$i_hosts])
            #{     
	    #  undef $download_flag[$i_hosts];
            #  ##print "turned off download flag for $dbcfilename[$i_hosts] \n";
            #}
            #$last_checksum[$i_hosts] = $this_checksum;
          
            # del any old dbcactive data for this instance number
            #if ($use_oracle eq "Y")
            #{
            runSQL("delete from dbamon.dbcactive where dbamonmode = '$modeout' and i_hosts = '$i_hosts'");
	    $sqltext = "insert into dbamon.dbcactive (dbamonmode,i_hosts,text)\n";
	    $sqltext .= "  values ('$modeout','$i_hosts','#--DBCFileName=$dbc_file--#')\n";
	    runSQL($sqltext);
            #}

	    undef $instance[$i_hosts];
            undef $mssql_instance[$i_hosts]; 
	    undef $backup_age[$i_hosts];
	    undef $backup_age_parm[$i_hosts];
	    undef $backup_age_arc[$i_hosts];
	    undef $backup_age_full[$i_hosts];
	    undef $backup_age_parm_arc[$i_hosts];
	    undef $backup_dbs[$i_hosts];
	    undef $backup_command[$i_hosts];
	    undef $comm_method[$i_hosts];
	    undef $config[$i_hosts];
	    undef $dbms[$i_hosts];
	    undef $download_every[$i_hosts];
	    undef $h_userlist[$i_hosts];
	    undef $host_url[$i_hosts];
	    undef $hostname[$i_hosts];

	    undef $id1[$i_hosts];
	    undef $id2[$i_hosts];
	    undef $id3[$i_hosts];
	    undef $id4[$i_hosts];
	    undef $id5[$i_hosts];
	    undef $id6[$i_hosts];
	    undef $id7[$i_hosts];
	    undef $id8[$i_hosts];
	    undef $id9[$i_hosts];
	    undef $id10[$i_hosts];
	    undef $id11[$i_hosts];
	    undef $id12[$i_hosts];
	    undef $id13[$i_hosts];
	    undef $id14[$i_hosts];
	    undef $id15[$i_hosts];
	    undef $id16[$i_hosts];
	    undef $id17[$i_hosts];
	    undef $id18[$i_hosts];
	    undef $id19[$i_hosts];
	    undef $id20[$i_hosts];

	    undef $df_offline_sev[$i_hosts];
	    undef $infdir[$i_hosts];
	    undef $infname[$i_hosts];
	    undef $infver[$i_hosts];
	    undef $l0_age[$i_hosts];
	    undef $lclrmt[$i_hosts];
	    undef $hostfix[$i_hosts];
	    undef $max_extents[$i_hosts];
	    undef $memwin[$i_hosts];
	    undef $mon_days[$i_hosts];
	    undef $mon_excl[$i_hosts];
	    undef $mon_hours[$i_hosts];
	    undef $ntrcpbug[$i_hosts];
	    undef $opc_appl[$i_hosts];
	    undef $opc_gw[$i_hosts];
	    undef $opc_mg[$i_hosts];
	    undef $opc_obj[$i_hosts];
	    undef $dbc_class[$i_hosts];
	    undef $oemport[$i_hosts];
	    undef $isqlport[$i_hosts];
	    undef $dbc_event_email_for_sevs[$i_hosts];
	    undef $dbc_udm_stringcheck[$i_hosts];

            #---- Don't undef this. undef-ing it makes too many downloads occur 
	    #undef $orahome[$i_hosts];

	    undef $orasid[$i_hosts];
	    undef $pager_email[$i_hosts];
	    undef $pager_subject[$i_hosts];
	    undef $perlpath[$i_hosts];
	    undef $runmon[$i_hosts];
	    undef $sapsid[$i_hosts];
	    undef $server[$i_hosts];
	    undef $ops[$i_hosts];
	    undef $sqlhosts[$i_hosts];
	    undef $t_arclog_c[$i_hosts];
	    undef $t_arclog_cmd[$i_hosts];
	    undef $t_arclog_w[$i_hosts];
	    undef $t_diskcrit[$i_hosts];
	    undef $t_diskwarn[$i_hosts];
	    undef $t_extents[$i_hosts];
	    undef $t_extents_fix[$i_hosts];
	    undef $t_freespace[$i_hosts];
	    undef $t_longtx[$i_hosts];
	    undef $t_mustbeup[$i_hosts];
	    undef $t_readhit[$i_hosts];
	    undef $t_writehit[$i_hosts];
	    undef $title1_dup[$i_hosts];
	    undef $title1[$i_hosts];
	    undef $title1url[$i_hosts];
	    undef $title2[$i_hosts];
	    undef $title2url[$i_hosts];
	    undef $title3[$i_hosts];
	    undef $ts_command[$i_hosts];
	    undef $userid[$i_hosts];
	    undef $useridap[$i_hosts];
	    undef $comn[$i_hosts];
	    undef $minproc_apache[$i_hosts];
	    undef $oraapfs[$i_hosts];
	    undef $parm_errors[$i_hosts];
	    undef $rootpath[$i_hosts];
	    undef $rootoffs[$i_hosts];
	    undef $os[$i_hosts];
	    undef $sw_version[$i_hosts];
	    undef $os_version[$i_hosts];
	    undef $hw_model[$i_hosts];
	    undef $sn[$i_hosts];
	    undef $is_prihost[$i_hosts];
	    undef $is_prisid[$i_hosts];
	    undef $check_datafiles[$i_hosts];
	    undef $is_threshold[$i_hosts];
	    undef $mssql_agentmon[$i_hosts];
	    undef $prevent_db_restart[$i_hosts];
	    undef $alert_log_check[$i_hosts];
	    undef $good_users_ts[$i_hosts];
	    undef $good_temp_ts[$i_hosts];
	    undef $priority[$i_hosts];
	    undef $make_tickets_dbc[$i_hosts];
	    undef $suppress_events[$i_hosts];
	    undef $run_surgery[$i_hosts];
	    undef $spfile[$i_hosts];

	    undef $rsh_service[$i_hosts];
	    undef $backup_method_long[$i_hosts];
	    undef $mr_backup_type[$i_hosts];
	    undef $mr_backup_date[$i_hosts];

	    undef $t_nuserproc_w[$i_hosts] ;
            undef $t_nuserproc_c[$i_hosts] ;

	    undef $sec_dbarole[$i_hosts] ;
	    undef $sec_dbarole_cnt[$i_hosts] ;
	    undef $sec_improle[$i_hosts] ;
	    undef $sec_improle_cnt[$i_hosts] ;
	    undef $sec_aupriv[$i_hosts] ;
	    undef $sec_aupriv_cnt[$i_hosts] ;
	    undef $sec_userpw[$i_hosts] ;
	    undef $sec_userpw_cnt[$i_hosts] ;
	    undef $sec_userpwchanged[$i_hosts] ;
	    undef $sec_userpwchanged_cnt[$i_hosts] ;
	    undef $sec_userpwsys[$i_hosts] ;
	    undef $sec_userpwsys_cnt[$i_hosts] ;
	    undef $sec_fileperm[$i_hosts] ;
	    undef $sec_fileperm_cnt[$i_hosts] ;
	    undef $sec_dbagrp_g[$i_hosts] ;
	    undef $sec_dbagrp_g_cnt[$i_hosts] ;
	    undef $sec_dbagrp_p[$i_hosts] ;
	    undef $sec_dbagrp_p_cnt[$i_hosts] ;

	    undef $db_cache_size[$i_hosts] ;
	    undef $granule_size[$i_hosts] ;

	    undef $hw_memory_size_gb[$i_hosts] ;
	    undef $hw_memory_free[$i_hosts] ;
	    undef $hw_memory_pct_full[$i_hosts] ;
	    undef $hw_memory[$i_hosts] ;

	    undef $probe[$i_hosts] ;
	    undef $probe_dir[$i_hosts] ;

	    undef $arclog_by_dest[$i_hosts] ;
	    undef $buffer_cache_size[$i_hosts] ;
	    undef $total_shmem[$i_hosts] ;
	    undef $instance_details[$i_hosts] ;
            undef $listener_check[$i_hosts] ;
            undef $t_sga_w[$i_hosts] ;
            undef $t_sga_c[$i_hosts] ;

            undef $redo_1day_count[$i_hosts] ;
            undef $redo_1day_perhour[$i_hosts] ;
            undef $redo_30day_avg_gb[$i_hosts] ;
            undef $redo_30day_max_gb[$i_hosts] ;
            undef $redo_archv_fs_gb[$i_hosts] ;
            undef $redo_archv_fs[$i_hosts] ;
            undef $redo_archv_ratio[$i_hosts] ;
            undef $redo_log_size[$i_hosts] ;

            undef $email_report[$i_hosts] ;

            undef $t_dfcount_pct_w[$i_hosts] ;
            undef $t_dfcount_pct_c[$i_hosts] ;

            undef $probe_parm[$i_hosts] ;

            undef $ssh_port[$i_hosts] ;
 
            undef $dbc_NTFE_events[$i_hosts];

            undef %{$mssql_job_cat_mbr[$i_hosts]};
            undef %{$mssql_job_name_mbr[$i_hosts]};

            undef %{$t_perf[$i_hosts]};

	    $dbcount[$i_hosts] = 0;
	    $udbcount[$i_hosts] = 0;
	    $dblist[$i_hosts] = ();

	    $dbcfile[$i_hosts] = $dbc_file;

	    $hostname[$i_hosts] = lc $F2;
	    if ($debug_read) { printf("Found Host %s\n",$hostname[$i_hosts]); }
	  }
	  else 
	  {
            ##print "skipping host=$F2 \n";
	    $alpha_flag = 0;
            close(DBC);
            next DBCFILE;
	  }
        }

        #---- Insert repository row
        #if ($F0 ne "" && $use_oracle eq "Y")
        if ($F0 ne "")
        {
	  $sqltext = "insert into dbamon.dbcactive (dbamonmode,i_hosts,text)\n";
	  chop($_ = $F0);
          #s/\\/\//g;
          s/&/[Ampersand]/g;
          s/\'/[SingleQuote]/g;
          $sqltext .= "  values ('$modeout','$i_hosts','$_')\n";
          runSQL($sqltext);
        }

        #---- Parse data

        #---- Save entire line for later
        $logdetails_dbc[$i_hosts] .= "<tr bgcolor=$table_rowcolor><td>$f_s <b>$F1</b> <td>$f_s $F2 $F3 $F4 $F5\n";
 
        #---- 2013/04/24 - A new way to save DBC parms
        ($zwork = lc $F1) =~ s/\:$//; 
        print "zwork=$zwork\n" if $debug_r; 
        $dbc_parm[$i_hosts]{$zwork} = $F2;

        #---- The start of the huge IF/ELSIF
	if    ($F1 eq "Comm_Method:")      { $comm_method[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title1:")           
        { 
          # At this point the title1 var should be null; if it isn't, then there must be dup title1 entries
          ##print "t1b4=$title1[$i_hosts] \n";
          if ($title1[$i_hosts] ne "") 
          { 
            $title1_dup[$i_hosts] = 1; 
            ##print "t1di=$title1_dup[$i_hosts] \n";
          }
     
          #---- Examine Title1 Length
          $title1_max_len = 20; 
          $title1[$i_hosts]  = $F2; 
	  $title1_len = length($title1[$i_hosts]);
	  if ($title1_len > $title1_max_len)
	  {
	    $msg = "Title1: value: $title1[$i_hosts] length of $title1_len exceeds maximum of $title1_max_len - truncated";
	    error_msg($msg,$i_hosts);
	    $title1[$i_hosts] = substr($title1[$i_hosts],0,$title1_max_len);
	  }
        }
	elsif ($F1 eq "Title2:")           { $title2[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title3:")           { $title3[$i_hosts]  = $F2; }
	elsif ($F1 eq "SSH_Port:")         { $ssh_port[$i_hosts]  = $F2; }
	elsif ($F1 eq "Host_URL:")         { $host_url[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title1_URL:")       { $title1url[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title2_URL:")       { $title2url[$i_hosts]  = $F2; }
	elsif ($F1 eq "Userid:")           { $userid[$i_hosts]   = $F2; }
	elsif ($F1 eq "Suppress_Events:")  { $suppress_events[$i_hosts] = $F2; }
	elsif ($F1 eq "EMail_Report:")     { $email_report[$i_hosts] = $F2; }
	elsif ($F1 eq "Run_Surgery:")      { $run_surgery[$i_hosts] = $F2; }
	elsif ($F1 eq "Probe_Parm:")       { $probe_parm[$i_hosts] = $F2; }

	elsif ($F1 eq "DBMS:")             
        { 
          #See if this has already been specified
          if ($dbms[$i_hosts] ne "") 
          {
            $parm_errors[$i_hosts] .= "Error - DBMS was specified TWICE in this DBC file\n"; 
            next DBCFILE;
          }
          $dbms[$i_hosts] = $F2; 
        }

	elsif ($F1 eq "SWPackage:")        { $dbms[$i_hosts] = $F2; }
	elsif ($F1 eq "DBC_Class:")        { $dbc_class[$i_hosts] = $F2; }
	elsif ($F1 eq "Alert_Log_Check:")  { $alert_log_check[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor:")          { $runmon[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor_Hours:")    { $mon_hours[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor_Days:")     { $mon_days[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor_Exclude:")  { $mon_excl[$i_hosts] = $F2; }
	elsif ($F1 eq "Download_Every:")   { $download_every[$i_hosts] = $F2; }
	elsif ($F1 eq "Perl_Path:")        { $perlpath[$i_hosts] = $F2; }
	elsif ($F1 eq "Check_Datafiles:")  { $check_datafiles[$i_hosts] = $F2; }

	elsif ($F1 eq "ID1:")              { $id1[$i_hosts] = $F2; }
	elsif ($F1 eq "ID2:")              { $id2[$i_hosts] = $F2; }
	elsif ($F1 eq "ID3:")              { $id3[$i_hosts] = $F2; }
	elsif ($F1 eq "ID4:")              { $id4[$i_hosts] = $F2; }
	elsif ($F1 eq "ID5:")              { $id5[$i_hosts] = $F_noun; }
	elsif ($F1 eq "ID6:")              { $id6[$i_hosts] = $F2; }
	elsif ($F1 eq "ID7:")              { $id7[$i_hosts] = $F2; }
	elsif ($F1 eq "ID8:")              { $id8[$i_hosts] = $F2; }
	elsif ($F1 eq "ID9:")              { $id9[$i_hosts] = $F2; }
	elsif ($F1 eq "ID10:")             { $id10[$i_hosts] = $F2; }
	elsif ($F1 eq "ID11:")             { $id11[$i_hosts] = $F_noun; }
	elsif ($F1 eq "ID12:")             { $id12[$i_hosts] = $F_noun; }
	elsif ($F1 eq "ID13:")             { $id13[$i_hosts] = $F_noun; }
	elsif ($F1 eq "ID14:")             { $id14[$i_hosts] = $F_noun; }
	elsif ($F1 eq "ID15:")             { $id15[$i_hosts] = $F_noun; }
	elsif ($F1 eq "ID16:")             { $id16[$i_hosts] = $F_noun; }
	elsif ($F1 eq "ID17:")             { $id17[$i_hosts] = $F_noun; }
	elsif ($F1 eq "ID18:")             { $id18[$i_hosts] = $F_noun; }
	elsif ($F1 eq "ID19:")             { $id19[$i_hosts] = $F_noun; }
	elsif ($F1 eq "ID20:")             { $id20[$i_hosts] = $F_noun; }

	elsif ($F1 eq "NT_RCP_Bug:")       { $ntrcpbug[$i_hosts] = $F2; }
	elsif ($F1 eq "UseridApps:")              { $useridap[$i_hosts]   = $F2; }
	elsif ($F1 eq "OraApps_Userid:")          { $useridap[$i_hosts]   = $F2; }
	elsif ($F1 eq "OraApps_COMN_Dir:")        { $comn[$i_hosts] = $F2; }
	elsif ($F1 eq "OraApps_Minproc_Apache:")  { $minproc_apache[$i_hosts] = $F2; }
	elsif ($F1 eq "OraApps_Forms_ORAHOME:")   { $forms_orahome[$i_hosts] = $F2; }
	elsif ($F1 eq "OraApps_FS_Check:")        { $oraapfs[$i_hosts] .= "$F2 "; }

	elsif ($F1 eq "Event_EMail_For_Sevs:")      { $dbc_event_email_for_sevs[$i_hosts] = $F2; }

	elsif ($F1 eq "FS_Check_Mask:")      { $fs_check_mask[$i_hosts]      = $F2; }
	elsif ($F1 eq "FS_Check_Threshold:") { $fs_check_threshold[$i_hosts] = $F2; }
        elsif ($F1 eq "FS_Check_EMail:") 
        {
          $z = index($F0,$F2);
          chop($fs_check_email[$i_hosts] = substr($F0,$z));
        }

	elsif ($F1 eq "ORACLE_HOME:")      { $orahome[$i_hosts] = $F2; }
	elsif ($F1 eq "ORACLE_SID:")       
        {
          $orasid[$i_hosts] = $F2;
          # This is for the inhib file name
          $server[$i_hosts] = $F2 ;
        }
	elsif ($F1 eq "SAPSYSTEMNAME:")       
        {
          $sapsid[$i_hosts] = $F2;
          # This is for the inhib file name
          $server[$i_hosts] = $F2 ;
        }
        elsif ($F1 eq "Config:")
        {
          @words = split(/\//,$F2);
	  $server[$i_hosts]   = $words[0];
	  $config[$i_hosts]   = $words[1];
        }
	elsif ($F1 eq "Inf_Server:"   || $F1 eq "INFORMIXSERVER:") { $server[$i_hosts] = $F2 }
	elsif ($F1 eq "ON_Config:"    || $F1 eq "ONCONFIG:")    { $config[$i_hosts] = $F2 }
	elsif ($F1 eq "SQL_Hosts:"    || $F1 eq "INFORMIXSQLHOSTS:")    { $sqlhosts[$i_hosts] = $F2 }
	elsif ($F1 eq "Informix_Dir:" || $F1 eq "INFORMIXDIR:") { $infdir[$i_hosts]   = $F2 }
	elsif ($F1 eq "Informix_Version:") { $infver[$i_hosts]   = $F2 }
        # Made obsolete 21May01
	#elsif ($F1 eq "Local_Or_Remote:")  { $lclrmt[$i_hosts]   = $F2 }
        elsif ($F1 eq "T_Disk_Full:" || $F1 eq "T_TS_Full:" || $F1 eq "T_DBSpace_Full:")
        {
          @words = split(/\//,$F2);
	  $t_diskwarn[$i_hosts] = $words[0];
	  $t_diskcrit[$i_hosts] = $words[1];
          ##print "tdw=$t_diskwarn[$i_hosts] tdc=$t_diskcrit[$i_hosts] F2=$F2 \n";
        }
        elsif ($F1 eq "T_FG_Full:")    #---- For SQL FILEGROUPS - New 2011/01/05
        {
          @words = split(/\//,$F2);
	  $t_fgwarn[$i_hosts] = $words[0];
	  $t_fgcrit[$i_hosts] = $words[1];
          ##print "tdw=$t_diskwarn[$i_hosts] tdc=$t_diskcrit[$i_hosts] F2=$F2 \n";
        }
        elsif ($F1 eq "T_DFCount_Pct:")
        {
          @words = split(/\//,$F2);
	  $t_dfcount_pct_w[$i_hosts] = $words[0];
	  $t_dfcount_pct_c[$i_hosts] = $words[1];
        }
        elsif ($F1 eq "T_NUSERPROC:" || $F1 eq "T_TS_Full:" || $F1 eq "T_DBSpace_Full:")
        {
          @words = split(/\//,$F2);
	  $t_nuserproc_w[$i_hosts] = $words[0];
	  $t_nuserproc_c[$i_hosts] = $words[1];
          &debug($i_hosts, "t_nuserproc_w[$i_hosts]=$t_nuserproc_w[$i_hosts] t_nuserproc_c[$i_hosts]=$t_nuserproc_c[$i_hosts] F2=$F2");
        }
        elsif ($F1 eq "T_SGA_Full:")
        {
          @words = split(/\//,$F2);
	  $t_sga_w[$i_hosts] = $words[0];
	  $t_sga_c[$i_hosts] = $words[1];
        }
	elsif ($F1 eq "T_TS_Command:") 
        {
          $z = index($F0,$F2);
          $ts_command[$i_hosts]    = substr($F0,$z);
          chop($ts_command[$i_hosts]);
          ##print "tsc=$ts_command[$i_hosts] \n";
        }

        #---- Method #1 - all destinations
        elsif (
               $F1 eq "T_Arclog_Full:" ||
               $F1 eq "T_Log_Full:"    || 
               $F1 eq "T_TLog_Full:" 
              )
        {
          @words = split(/\//,$F2);
	  $t_arclog_w[$i_hosts] = $words[0];
	  $t_arclog_c[$i_hosts] = $words[1];
        }
	elsif ($F1 eq "T_Arclog_Command:") 
        {
          $z = index($F0,$F2);
          $t_arclog_cmd[$i_hosts]    = substr($F0,$z);
          chop($t_arclog_cmd[$i_hosts]);
        }

        #---- Method #2 - by destinations
        elsif ($F1 eq "T_Arclog_Full_Dest:")
        {
          $zdest = $F2; 
          @zwords = split(/\//,$F3);
	  $zw = $zwords[0];
	  $zc = $zwords[1];

          $parm_errors[$i_hosts] .= "Error - T_Arclog_Full_Dest: Requires 2 Operands - Dest and W/C\n" if ! $F3; 
          $parm_errors[$i_hosts] .= "Error - T_Arclog_Full_Dest: Dest must be 1-10\n" if $zdest < 1 || $zdest > 10; 
          $parm_errors[$i_hosts] .= "Error - T_Arclog_Full_Dest: Warning threshold must be 1-100\n" if $zw < 1 || $zw > 100; 
          $parm_errors[$i_hosts] .= "Error - T_Arclog_Full_Dest: Critical threshold must be 1-100\n" if $zc < 1 || $zc > 100; 

          $t_arc_dest{$i_hosts}{$zdest}{threshold_w} = "$zw";
          $t_arc_dest{$i_hosts}{$zdest}{threshold_c} = "$zc";

          &logit("DEBUG t_arc_dest{$i_hosts}{$zdest}{threshold_w} = $t_arc_dest{$i_hosts}{$zdest}{threshold_w}");
          &logit("DEBUG t_arc_dest{$i_hosts}{$zdest}{threshold_c} = $t_arc_dest{$i_hosts}{$zdest}{threshold_c}");

          $arclog_by_dest[$i_hosts] = 1;
        }
	elsif ($F1 eq "T_Arclog_Cmd_Dest:") 
        {
          $parm_errors[$i_hosts] .= "Error - T_Arclog_Cmd_Dest: Requires 2 Operands - Dest and Command\n" if ! $F3; 

          $zdest = $F2; 
          $z = index($F0,$F3);
          chop($t_arc_dest{$i_hosts}{$zdest}{cmd} = substr($F0,$z));
          
          &logit("DEBUG t_arc_dest{$i_hosts}{$zdest}{cmd} = $t_arc_dest{$i_hosts}{$zdest}{cmd}");
        }

	elsif ($F1 eq "T_DBSpace_Free:" || $F1 eq "T_TS_Free:") { $t_freespace[$i_hosts] = $F2 }

	elsif ($F1 eq "T_Read_Hit:")      { $t_readhit[$i_hosts] = $F2 }
	elsif ($F1 eq "T_Read_Hit_Sev:")  { $t_readhit_sev[$i_hosts] = $F2 }

	elsif ($F1 eq "T_Write_Hit:")   { $t_writehit[$i_hosts] = $F2 }

	elsif ($F1 eq "T_MSSQL_VLF_Count:")   { $t_mssql_vlf_count[$i_hosts] = $F2 }

	elsif ($F1 eq "T_Long_Tx:")     { $t_longtx[$i_hosts] = $F2 }
	elsif ($F1 eq "T_Extents:")
        {     
          $t_extents[$i_hosts] = $F2;
          $t_extents_fix[$i_hosts] = $F3;
        }
	elsif ($F1 eq "OpC_Application:")  { $opc_appl[$i_hosts] = "$F2 $F3 $F4"; }
	elsif ($F1 eq "OpC_Object:")       { $opc_obj[$i_hosts] = $F2;  }
	elsif ($F1 eq "OpC_Msg_Group:")    { $opc_mg[$i_hosts] = $F2; }
	elsif ($F1 eq "OpC_Gateway:")      { $opc_gw[$i_hosts] = $F2; }
	elsif ($F1 eq "Must_Be_Up:")       { $t_mustbeup[$i_hosts] = $F2 }
	elsif ($F1 eq "Mem_Window:")       { $memwin[$i_hosts] = $F2 }

	elsif (uc $F1 eq "BACKUP_CHECK_DBS:")   { $backup_dbs[$i_hosts]         =  "," . lc $F2 . ","; }
	elsif (uc $F1 eq "BACKUP_NOCHECK_DBS:") { $backup_nocheck_dbs[$i_hosts] =  "," . lc $F2 . ","; }

	elsif ($F1 eq "In_Sync_Pri_Host:") { $is_prihost[$i_hosts] = $F2; }
	elsif ($F1 eq "In_Sync_Pri_SID:")  { $is_prisid[$i_hosts] = $F2; }
	elsif ($F1 eq "In_Sync_Age:")      { $is_threshold[$i_hosts] = $F2; }
	elsif ($F1 eq "In_Sync_NL_Sev:")   { $is_nolog_sev[$i_hosts] = $F2; }
	elsif ($F1 eq "In_Sync_Unrec_Sev:"){ $is_unrec_sev[$i_hosts] = $F2; }
	elsif ($F1 eq "DF_Offline_Sev:")   { $df_offline_sev[$i_hosts] = $F2; }
	elsif ($F1 eq "Listener_Check:")   { $listener_check[$i_hosts] = $F2; }
	elsif ($F1 eq "Priority:")         { $priority[$i_hosts] = $F2; }
	elsif ($F1 eq "Make_Tickets:")     { $make_tickets_dbc[$i_hosts] = $F2; }

	elsif ($F1 eq "No_Tickets_For_Events:")  { $dbc_NTFE_events[$i_hosts] = $F2; }

	elsif ($F1 eq "Events:")           { $events_dbc[$i_hosts] = $F2; }
	elsif ($F1 eq "Prevent_DB_Restart:") { $prevent_db_restart[$i_hosts] = $F2; }
	elsif ($F1 eq "Backup_Age:")       
        { 
          $backup_age[$i_hosts] = $F2; 
          $backup_age_parm[$i_hosts] = $F3; 
        }
	elsif ($F1 eq "Backup_Age_Arc:" || uc $F1 eq "BACKUP_AGE_TLOG:")       
        { 
          $backup_age_arc[$i_hosts] = $F2; 
          $backup_age_parm_arc[$i_hosts] = $F3; 
        }
	elsif (uc $F1 eq "BACKUP_AGE_FULL_DAYS:")       
        { 
          $backup_age_full[$i_hosts] = $F2; 
        }
	elsif ($F1 eq "Backup_Command:") 
        {
          $z = index($F0,$F2); 
          chop($backup_command[$i_hosts]    = substr($F0,$z));
          $backup_rerun_iter[$i_hosts] = 9999999 if $iter_count == 1; 
          ##print "z=$z bc=$backup_command[$i_hosts] \n";
        }
	elsif ($F1 eq "L0_Age:")         { $l0_age[$i_hosts] = $F2 }
	elsif ($F1 eq "Max_Extents:")    { $max_extents[$i_hosts] = $F2 }
	elsif ($F1 eq "Pager_Subject:")  { $pager_subject[$i_hosts] = $F2; }
	elsif ($F1 eq "Pager_EMail:")    { $pager_email[$i_hosts] = "$F2 $F3 $F4"; }

        #---- New way - values saved above in dbc_parm
	elsif (lc $F1 eq "mssql_tran_duration_hrs:") {  }
	elsif (lc $F1 eq "mssql_tran_tlog_gb:")      {  }
	elsif (lc $F1 eq "prime_time_lrc_check:")    {  }
	elsif (lc $F1 eq "sla:")                     {  }

        #---- 2013/11/22 - New 
	elsif (lc $F1 eq "perf_events_during_shifts:")       {  }

	elsif ($F1 eq "MSSQL_Agent_Mon:") { $mssql_agentmon[$i_hosts] = $F2; }

	elsif ($F1 eq "MSSQL_String_Check:") { $dbc_udm_stringcheck[$i_hosts] = $F2; }

	elsif ($F1 eq "MSSQL_Log_Min_Sev:") { $mssql_log_min_sev[$i_hosts] = $F2; }

	elsif ($F1 eq "MSSQL_Job_Fail_Check:") { $mssql_job_fail_check[$i_hosts] = $F2; }

	elsif ($F1 eq "MSSQL_Job_OK_Owners:")  { $mssql_job_ok_owners[$i_hosts] = $F2; }

	elsif ($F1 eq "MSSQL_DB_OK_Owners:")  { $mssql_db_ok_owners[$i_hosts] = $F2; }

	elsif ($F1 eq "MSSQL_Repl_Lag_Excl_String:")  { $mssql_repl_lag_excl_string[$i_hosts] = $F2; }

	elsif ($F1 eq "MSSQL_Job_LR_Check_Name_Excl_String:")   { $mssql_job_lr_check_name_excl_string[$i_hosts]  = $F2; }

	elsif ($F1 eq "MSSQL_Job_Check_Cat_Excl_String:")   { $mssql_job_check_cat_excl_string[$i_hosts]  = $F2; }

	elsif ($F1 eq "MSSQL_Job_Check_Name_Excl_String:")  { $mssql_job_check_name_excl_string[$i_hosts] = $F2; }

	elsif ($F1 eq "MSSQL_Addtl_Drives:")  { $mssql_addtl_drives[$i_hosts] = uc $F2; }
	elsif ($F1 eq "OSWin_Addtl_Drives:")  { $mssql_addtl_drives[$i_hosts] = uc $F2; }

	elsif ($F1 eq "MSSQL_Instance:") 
        { 
          $mssql_instance[$i_hosts] = $F2; 
          $server[$i_hosts] = $F2 ;
        }

	elsif ($F1 eq "Perf_Metric_Label:") 
        { 
          $perf_metric_label[$i_hosts]{$F2} = $F3;
          $perf_metric_label[$i_hosts]{$F2} .= " $F4" if $F4;
          $perf_metric_label[$i_hosts]{$F2} .= " $F5" if $F5;
          $perf_metric_label[$i_hosts]{$F2} .= " $F6" if $F6;
          $perf_metric_label[$i_hosts]{$F2} .= " $F7" if $F7;
          $perf_metric_label[$i_hosts]{$F2} .= " $F8" if $F8;
          $perf_metric_label[$i_hosts]{$F2} .= " $F9" if $F9;
          $perf_metric_label[$i_hosts]{$F2} .= " $F10" if $F10;
        }

	elsif ($F1 eq "MSSQL_DDP_Job_Cat_MBR:") 
        { 
          &packetParse($F0); 
          foreach $this_field (@pa_words)
          {
            $this_field = uc $this_field; 
            ##print "DEBUG_RDBC: $this_field\n"; 
            $mssql_job_cat_mbr[$i_hosts]{$this_field} = 1;
          }
        }

	elsif ($F1 eq "MSSQL_DDP_Job_Name_MBR:") 
        { 
          &packetParse($F0); 
          foreach $this_field (@pa_words)
          {
            $this_field = uc $this_field; 
            ##print "DEBUG_RDBC: $this_field\n"; 
            $mssql_job_name_mbr[$i_hosts]{$this_field} = 1;
          }
        }

	elsif ($F1 eq "T_PerfCounter:") 
        { 
          #---- F1: Noun (COUNTER NAME) F2: warning/critical
          my $zcounter = uc $F2; 
          my @zwords = split(/\//,$F3);
	  my $zwarn  = $zwords[0];
	  my $zcrit  = $zwords[1];
          my $zoperator = uc $F4; 
          $zoperator = "GE" if ! $zoperator;
          my $zeventsev = uc $F5; 
          
          $zusage = "Usage: 'T_Perf: PerfCounterName WarningThreshold/CriticalThreshold LE|LT|GE|GT P|C' - "; 

          if    ($zcounter eq "") { $parm_errors[$i_hosts] .= "$zusage (PerfCounterName is NULL)"; }
          elsif ($zwarn eq "")    { $parm_errors[$i_hosts] .= "$zusage (WarningThreshold is NULL)"; }
          elsif ($zcrit eq "")    { $parm_errors[$i_hosts] .= "$zusage (CriticalThreshold is NULL)"; }
          elsif ($zoperator ne "GT" && 
                 $zoperator ne "GE" && 
                 $zoperator ne "LT" && 
                 $zoperator ne "LE") 
          { $parm_errors[$i_hosts] .= "$zusage (Comparison Operator must be GT, GE, LT or LE)"; }
          elsif ($zeventsev && 
                 $zeventsev ne "P" && 
                 $zeventsev ne "C") 
          { $parm_errors[$i_hosts] .= "$zusage (Event Sev must be C or P or NULL)"; }
          else
          {
            $t_perf_w[$i_hosts]{$zcounter} = $zwarn;
            $t_perf_c[$i_hosts]{$zcounter} = $zcrit;
            $t_perf_operator[$i_hosts]{$zcounter} = $zoperator;
            $t_perf_eventsev[$i_hosts]{$zcounter} = $zeventsev;
          }
        }

 	elsif ($F1 eq "Notify_List:")  
        {
          $h_userlist[$i_hosts] = $F2;
        }

        else
        {
          if ($F1 ne "Host:")
          {
            $zfile = "$parmdir/$dbc_file";
	    $msg = "Error - Unknown DBC parameter: $F1 specified in DBC file: $zfile";
	    #error_msg($msg);
	    #logit($msg);
            $parm_errors[$i_hosts] .= "$msg\n";
          }
        }
      }      
      close(DBC);

      ##if ($company eq "thecompany")
      ##{
      ##  chop($datechk = `date +%C%y/%m/%d-%H:%M:%S`);
      ##  if ($datechk ge "2001/05/19-12:00:00" &&  $datechk le "2001/05/20-12:00:00")
      ##  {
      ##    $t_mustbeup[$i_hosts] = "N";
      ##    logit("Must_Be_Up: Forced to N for host: $hostname[$i_hosts]:$title1[$i_hosts] ");
      ##  }
      ##}

      #---- Fill in DBMS if not specified
      if ($dbms[$i_hosts] eq "")        
      { 
        if ($df_dbms) { $dbms[$i_hosts] = $df_dbms }
        else          { $dbms[$i_hosts] = "Informix" }
      }
      ##print "DEBUG - DBMS=$dbms[$i_hosts] df_dbms=$df_dbms\n"; 

      #---- New v5 - If Title1 is NOT specified, build it from the instance name
      if (! $title1[$i_hosts]) 
      {
        $zhostfirst = (split(/\./,$hostname[$i_hosts])) [0];
        if ($dbms[$i_hosts] eq "Oracle") 
        {
          $title1[$i_hosts] = "${zhostfirst}_$orasid[$i_hosts]"; 
        }  
        elsif ($dbms[$i_hosts] eq "MSSQL") 
        {
          #2010/12/23 if ($mssql_instance[$i_hosts]) { $title1[$i_hosts] = "${zhostfirst}/${mssql_instance[$i_hosts]}"; }
          #2010/12/23 else                           { $title1[$i_hosts] = "${zhostfirst}/MSSQLSERVER"; }
          if ($mssql_instance[$i_hosts]) { $title1[$i_hosts] = "${mssql_instance[$i_hosts]}"; }
          else                           { $title1[$i_hosts] = "MSSQLSERVER"; }
        }  
        &logit("  Title1 Not specified for dbcfilename=$dbcfilename[$i_hosts] - Using: $title1[$i_hosts]") if $debug_r; 
      }

      #---- Old
      # Process various parm for this instance
      #  $_ = $title1[$i_hosts];
      #  s/\//_/g;  # change slashes to underscores
      #  $infname[$i_hosts]  = $_;
      #---- New
      $infname[$i_hosts] = $title1[$i_hosts];
      $infname[$i_hosts]  =~ s/\//_/g;     #---- change slashes to underscores
     
      if (         length("$hostname[$i_hosts]_$infname[$i_hosts]") > $longest)
      {  
	$longest = length("$hostname[$i_hosts]_$infname[$i_hosts]");
        ##print "DEBUG - longest set to $longest\n"; 
      }

      $m_critical[$i_hosts] = 0;
      $m_warning[$i_hosts]  = 0;
      $m_info[$i_hosts]  = 0;
      $m_user[$i_hosts]  = 0;
      $m_sec[$i_hosts]  = 0;
      $m_perf[$i_hosts]  = 0;
      $m_note[$i_hosts]  = 0;

      $t_critical[$i_hosts] = 0;
      $t_warning[$i_hosts]  = 0;
      $t_info[$i_hosts]  = 0;

      $up[$i_hosts]       = " ";

      #---- Set instance_key
      $instance_key[$i_hosts] = "${modeout}-${i_hosts}";

      if ($dbms[$i_hosts] eq "SAP" && $userid[$i_hosts] eq "")
      {
	$userid[$i_hosts] = lc $sapsid[$i_hosts] . "adm";
      }

      #---- Old
      #if ($userid[$i_hosts] ne "")
      #{
      #  $tuserid = " -l $userid[$i_hosts] ";
      #}
      #else
      #{
      #  $tuserid = " ";
      #}

      #---- New 2012/09/10 5.38.B
      if ($userid[$i_hosts] =~ /\\/ && $g_quote_domain_users eq "Y")
      {
        $tuserid = " -l '$userid[$i_hosts]' ";
      }
      elsif ($userid[$i_hosts] ne "")
      {
        $tuserid = " -l $userid[$i_hosts] ";
      }
      else
      {
        $tuserid = " ";
      }
      &debug($i_hosts,"tuserid=$tuserid");

      if ($comm_method[$i_hosts] eq "ssh")
      {
        $tcomm = "ssh";
      }
      else
      {
        $tcomm = "remsh";
      }

      #---- Validation
      ##print "$hostname[$i_hosts] $title1[$i_hosts] \n";

      if ($dbc_udm_stringcheck[$i_hosts] && $dbc_udm_stringcheck[$i_hosts] !~ /\//)  
      { 
        $parm_errors[$i_hosts] .= "Error - DBC_String_Check: Must contain a SLASH (string/varnam)\n"; 
      }
      if ($hostname[$i_hosts] eq "")               { $parm_errors[$i_hosts] .= "Error - Null Host: DBC Parameter\n"; }
      if ($title1[$i_hosts] eq "")                 { $parm_errors[$i_hosts] .= "Error - Null Title1: DBC Parameter\n"; }
      if ($title1_dup[$i_hosts])                   { $parm_errors[$i_hosts] .= "Error - Duplicate Title1: Parameter Found\n"; }
      if ($t_extents_fix[$i_hosts] ne "" && $t_extents_fix[$i_hosts] ne "NOFIX")  
      { 
        $parm_errors[$i_hosts] .= "Error - 2nd parm of T_Extents: must be null or NOFIX\n"; 
      }
      if ($backup_age_parm[$i_hosts] ne "" && $backup_age_parm[$i_hosts] ne "ARC")  
      { 
        $parm_errors[$i_hosts] .= "Error - 2nd parm of Backup_Age: must be null or ARC\n"; 
      }

      if (
          ($dbms[$i_hosts] eq "Oracle") && 
          ($is_prihost[$i_hosts] ne "" ||
           $is_prisid[$i_hosts] ne "" ||
           $is_threshold[$i_hosts] ne "")
         &&
          ($is_prihost[$i_hosts] eq "" ||
           $is_prisid[$i_hosts] eq "" ||
           $is_threshold[$i_hosts] eq "")
         )
      { 
        $parm_errors[$i_hosts] .= "If any of the three In_Sync* parms are specified, they all must be specifed\n"; 
      }

      if ($is_nolog_sev[$i_hosts] ne "" &&
          $is_nolog_sev[$i_hosts] ne "C" &&
          $is_nolog_sev[$i_hosts] ne "W")
      { 
        $parm_errors[$i_hosts] .= "In_Sync_NL_Sev must be specifed as Null, C or W\n"; 
      }

      #if ($id9[$i_hosts] ne "" &&
      #    $id9[$i_hosts] ne "Restricted")
      #{ 
      #  $parm_errors[$i_hosts] .= "ID9: Must be Restricted or Null\n"; 
      #}

      if ($priority[$i_hosts] &&
          $priority[$i_hosts] ne "H" &&
          $priority[$i_hosts] ne "M" &&
          $priority[$i_hosts] ne "L")
      { 
        $parm_errors[$i_hosts] .= "Priority must be specifed as H, M or L\n"; 
      }

      if ($make_tickets_dbc[$i_hosts] &&
          $make_tickets_dbc[$i_hosts] ne "Y" &&
          $make_tickets_dbc[$i_hosts] ne "N")
      { 
        $parm_errors[$i_hosts] .= "Make_Tickets must be specifed as Y or N\n"; 
      }

      if ($events_dbc[$i_hosts] &&
          $events_dbc[$i_hosts] ne "Y" &&
          $events_dbc[$i_hosts] ne "N")
      { 
        $parm_errors[$i_hosts] .= "Events must be specifed as Y or N\n"; 
      }

      if ($runmon[$i_hosts] &&
          $runmon[$i_hosts] ne "B" &&
          $runmon[$i_hosts] ne "Y" &&
          $runmon[$i_hosts] ne "N")
      { 
        $parm_errors[$i_hosts] .= "Monitor (specified as $runmon[$i_hosts]) must be B, Y or N\n"; 
      }

      ##print "$hostname[$i_hosts] $title1[$i_hosts] $parm_errors[$i_hosts]\n";

      #---- Host DBC Defaults 
      if ($comm_method[$i_hosts] eq "") { $comm_method[$i_hosts] = "ssh"  }
      if ($runmon[$i_hosts] eq "")      { $runmon[$i_hosts] = "Y"  }
      if ($infver[$i_hosts] eq "")      { $infver[$i_hosts] = "7"  }
      if ($lclrmt[$i_hosts] eq "")      { $lclrmt[$i_hosts] = "R"  }
      if ($t_freespace[$i_hosts] eq "") { $t_freespace[$i_hosts] = 999999999 }

      if ($t_mustbeup[$i_hosts] eq "")  { $t_mustbeup[$i_hosts] = "Y" }
      if ($l0_age[$i_hosts] eq "")      { $l0_age[$i_hosts] = 30 }
      if ($perlpath[$i_hosts] eq "")    { $perlpath[$i_hosts] = "perl"  }
      if ($is_nolog_sev[$i_hosts] eq "") { $is_nolog_sev[$i_hosts] = "C"  }

      if ($t_mssql_vlf_count[$i_hosts] eq "") { $t_mssql_vlf_count[$i_hosts] = $df_t_mssql_vlf_count; }

      if ($backup_age_full[$i_hosts] eq "" && 
          $df_mssql_backup_age_full > 0 ) { $backup_age_full[$i_hosts] = $df_mssql_backup_age_full; }

      if ($priority[$i_hosts] eq "")    
      {
        $priority[$i_hosts] = "M";   # Default
        if    ($pager_email[$i_hosts])       { $priority[$i_hosts] = "H" }
        if    ($t_mustbeup[$i_hosts] eq "N") { $priority[$i_hosts] = "L" }
      }

      if ($mssql_job_fail_check[$i_hosts] eq "") { $mssql_job_fail_check[$i_hosts] = $df_mssql_job_fail_check; }
      $parm_errors[$i_hosts] .= "Error - MSSQL_Job_Fail_Check: Must be Y or N\n" 
        if $mssql_job_fail_check[$i_hosts] ne "Y" and $mssql_job_fail_check[$i_hosts] ne "N"; 

      if ($mssql_log_min_sev[$i_hosts] eq "")    { $mssql_log_min_sev[$i_hosts] = $df_mssql_log_min_sev; }
      $parm_errors[$i_hosts] .= "Error - MSSQL_Log_Min_Sev: Must be numeric, between 1 and 30\n" 
        if $mssql_log_min_sev[$i_hosts] < 1 || $mssql_log_min_sev[$i_hosts] > 30; 

      #---- Defaults for T_PerfCounter:
      ## $df_t_perfcounter{$zcounter} = "$zwarn/$zcrit/$zoperator/$zeventsev";
      ##      $t_perf_w[$i_hosts]{$zcounter} = $zwarn;
      ##      $t_perf_c[$i_hosts]{$zcounter} = $zcrit;
      ##      $t_perf_operator[$i_hosts]{$zcounter} = $zoperator;
      ##      $t_perf_eventsev[$i_hosts]{$zcounter} = $zeventsev;
      #---- Read through all DF values. If we don't have that specified in this DBC, then use that value
      foreach $this_counter (sort keys %df_t_perfcounter) 
      {
        if ($t_perf_w[$i_hosts]{$this_counter} eq "")  
        {
          ##print "Set t_perf_ctr $this_counter to $df_t_perfcounter{$this_counter} for $titleraw[$i_hosts]\n" if 1 == 1; ;
          @zwords = split(/\//,$df_t_perfcounter{$this_counter});
          $t_perf_w[$i_hosts]{$this_counter} = $zwords[0];
          $t_perf_c[$i_hosts]{$this_counter} = $zwords[1];
          $t_perf_operator[$i_hosts]{$this_counter} = $zwords[2];
          $t_perf_eventsev[$i_hosts]{$this_counter} = $zwords[3];
        }
      }

      #---- New way
      if ($dbc_parm[$i_hosts]{'mssql_tran_duration_hrs'} eq "")
      { 
        ##print "cf=$config_parm{'default_mssql_tran_duration_hrs'}\n";  
        $dbc_parm[$i_hosts]{'mssql_tran_duration_hrs'} = $config_parm{'default_mssql_tran_duration_hrs'} ; 
      }
      if ($dbc_parm[$i_hosts]{'mssql_tran_tlog_gb'}      eq "") 
      { 
        $dbc_parm[$i_hosts]{'mssql_tran_tlog_gb'}      = $config_parm{'default_mssql_tran_tlog_gb'}      ; 
      }

      #---- New way - SLA
      if ($dbc_parm[$i_hosts]{'sla'} eq "") 
      { 
        $dbc_parm[$i_hosts]{'sla'} = $config_parm{'default_sla'}; 
      }

      #---- A few HARD-CODED parms (for now)
      $t_lrbackup_age_hrs[$i_hosts] = 16; 
      $t_mssql_signal_wait_pct = 25;
     
      #---- Evaluate DBMS
      $what[$i_hosts] = "DB";

      $os_version[$i_hosts] = "?";

      if ($dbms[$i_hosts] eq "Informix") 
      {
        ##print "INFORMIX $titleraw[$i_hosts] i_hosts=$i_hosts\n"; 
	$num_informix++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
      }
      elsif ($dbms[$i_hosts] eq "Oracle")   
      {
	$num_oracle++;
        $dbtot_oracle++;
        ##print "num_oracle incremented to $num_oracle - host=$hostname[$i_hosts] \n";
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
      }
      elsif ($dbms[$i_hosts] eq "OracleApps")   
      {
	$what[$i_hosts] = "AP";
	$num_oracleapps++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
      }
      elsif ($dbms[$i_hosts] eq "SAP")   
      {
	$what[$i_hosts] = "AP";
	$num_sap++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
      }
      elsif ($dbms[$i_hosts] eq "MSSQL")  
      {
	$num_mssql++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "NT"; }
	$server[$i_hosts] = "MSSQLSERVER" if $mssql_instance[$i_hosts] eq "";
      }
      elsif ($dbms[$i_hosts] eq "OracleNT")  
      {
	$num_oraclent++;
        $dbtot_oraclent++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "NT"; }
      }
      elsif ($dbms[$i_hosts] eq "OSWin")  
      {
	$num_oswin++;
        $dbtot_oswin++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "NT"; }
      }
      else 
      {
	$num_unknown++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "??"; }
	$msg = "DBMS: Value: $dbms[$i_hosts] Invalid for Host: $hostname[$i_hosts]";
	&error_msg($msg,$i_hosts);
        $runmon[$i_hosts] = "N";
      }

      if ($debug_read) { printf("Processing Host/Instance %s/%s\n",$hostname[$i_hosts],$infname[$i_hosts]) }

      # Prevent errors
      ##print "ih=$i_hosts host=$hostname[$i_hosts] cm=$comm_method[$i_hosts] u=$userid[$i_hosts] dbms=$dbms[$i_hosts] \n";

      if ($comm_method[$i_hosts] eq "ssh" &&
          $dbms[$i_hosts] ne "OSWin" && 
          $dbms[$i_hosts] ne "Informix" && 
          $dbms[$i_hosts] ne "Oracle" && 
          $dbms[$i_hosts] ne "OracleNT" && 
          $dbms[$i_hosts] ne "SAP" && 
          $dbms[$i_hosts] ne "MSSQL")
      {
	$msg = "Comm_Method: ssh is only valid with DBMS: Oracle, OracleNT, Informix, OSWin, SAP and MSSQL";
	&error_msg($msg,$i_hosts);
	$comm_method[$i_hosts] = "";
        $parm_errors[$i_hosts] .= "Comm_Method: ssh is only valid with DBMS: OSWin, Oracle, OracleNT, SAP and MSSQL\n"; 
      }

      #---- populate the probe variable, if it hasn't been already
      if ($probe_dir[$i_hosts] eq "" && $os[$i_hosts] eq "UX")
      {
        $probe_dir[$i_hosts] = "/tmp/DBAmon_$userid[$i_hosts]"; 
        ##$probe_dir[$i_hosts] = "/tmp"; 
      }

      # Create remsh commands

      # Default remsh cmd
      $remshcmd[$i_hosts] = "remsh";

      if ($dbms[$i_hosts] eq "Informix")
      {
	if ($infver[$i_hosts] eq "5" && $lclrmt[$i_hosts] eq "L")
	{
	  $cmdpfx[$i_hosts]="export INFORMIXDIR=$infdir[$i_hosts];export TBCONFIG=$server[$i_hosts]" . 
	      ";export PATH=\$PATH:$infdir[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="";
	}

	if ($infver[$i_hosts] eq "5" && $lclrmt[$i_hosts] eq "R")
	{
	  $cmdpfx[$i_hosts]="$tcomm $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export TBCONFIG=$server[$i_hosts]" .
	      ";export PATH=\$PATH:$infdir[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	}

	if ($infver[$i_hosts] eq "6" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] eq "")
	{
	  $cmdpfx[$i_hosts]="$tcomm $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export INFORMIXSERVER=$server[$i_hosts];export ONCONFIG=$config[$i_hosts]" . 
	      ";export PATH=\$PATH:$infdir[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	}

	if ($infver[$i_hosts] eq "6" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] ne "")
	{
	  $cmdpfx[$i_hosts]="$tcomm $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export INFORMIXSERVER=$server[$i_hosts];export ONCONFIG=$config[$i_hosts];export INFORMIXSQLHOSTS=$sqlhosts[$i_hosts]" . 
	      ";export PATH=\$PATH:$infdir[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	}

	if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] eq "")
	{
	  $cmdpfx[$i_hosts]="$tcomm $hostname[$i_hosts] $tuserid " .
	      "'export INFORMIXDIR=$infdir[$i_hosts] " .
	      ";export INFORMIXSERVER=$server[$i_hosts] " .
	      ";export ONCONFIG=$config[$i_hosts] " .
	      ";export PATH=\$PATH:$infdir[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	}

	if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] ne "")
	{
	  $cmdpfx[$i_hosts]="$tcomm $hostname[$i_hosts] $tuserid " .
	      "'export INFORMIXDIR=$infdir[$i_hosts] " .
	      ";export INFORMIXSERVER=$server[$i_hosts] " .
	      ";export ONCONFIG=$config[$i_hosts] " .
	      ";export INFORMIXSQLHOSTS=$sqlhosts[$i_hosts] " .
	      ";export PATH=\$PATH:$infdir[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	}

        #---- Set probe path 
        $instance[$i_hosts] = $server[$i_hosts]; 
        $probe[$i_hosts] = "$probe_dir[$i_hosts]/dbamon_inf.pl"; 

        $remshcmd[$i_hosts] = $tcomm;

      }  # End of Informix

      if ($dbms[$i_hosts] eq "SAP")
      {
	if ($comm_method[$i_hosts] eq "ssh")
	{
	  $cmdpfx[$i_hosts]=
	    "ssh $hostname[$i_hosts] $tuserid '"     .
	    ". .profile;" . 
	    "export PATH=\$PATH:/usr/sap/$sapsid[$i_hosts]/SYS/exe/run/;" . 
	    "export SAPSYSTEMNAME=$sapsid[$i_hosts];" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "ssh";
	}
	else
	{
	  $cmdpfx[$i_hosts]=
	    "remsh $hostname[$i_hosts] $tuserid '"    .
	    ". .profile;" . 
	    "export PATH=\$PATH:/usr/sap/$sapsid[$i_hosts]/SYS/exe/run/;" . 
	    "export SAPSYSTEMNAME=$sapsid[$i_hosts];" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "remsh";
	}

        #---- Set probe path 
        $instance[$i_hosts] = $sapsid[$i_hosts]; 
        $probe[$i_hosts] = "$probe_dir[$i_hosts]/dbamon_sap.pl"; 
      }

      if ($dbms[$i_hosts] =~ /^Oracle/)
      {
	if ($orahome[$i_hosts] eq "*" && $save_orahome[$i_hosts] eq "")
	{
	  $download_flag[$i_hosts] = 0;
        }
	if ($orahome[$i_hosts] eq "*" && $save_orahome[$i_hosts] ne "")
	{
	  $orahome[$i_hosts] = $save_orahome[$i_hosts];
	  &logit("Re-Promoting ORACLE_HOME from * to $orahome[$i_hosts]",$i_hosts);
          #if ($use_oracle eq "Y")
          #{
	  # Update dbcactive table
	  runSQL("delete from dbamon.dbcactive where dbamonmode = '$modeout' and i_hosts = '$i_hosts' and text like 'ORACLE_HOME:%'");
	  $sqltext = "insert into dbcactive (dbamonmode,i_hosts,text)
	    values ('$modeout','$i_hosts','ORACLE_HOME: $orahome[$i_hosts]')";
	  runSQL($sqltext);
          #}
	}
	if ($comm_method[$i_hosts] eq "ssh")
	{
          $cmdpfx[$i_hosts]=
            "ssh $hostname[$i_hosts] $tuserid '"     .
            "export ORACLE_HOME=$orahome[$i_hosts];" . 
	    "export ORACLE_SID=$orasid[$i_hosts];"   .
	    "export PAGER_EMAIL=$pager_email[$i_hosts];"   .
	    "export PATH=\$PATH:$orahome[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "ssh";
          ##print "DEBUG cmdpfx[$i_hosts]=$cmdpfx[$i_hosts]\n";
	}
	else
	{
	  $cmdpfx[$i_hosts]=
	    "remsh $hostname[$i_hosts] $tuserid '"    .
	    "export ORACLE_HOME=$orahome[$i_hosts];"  .
	    "export ORACLE_SID=$orasid[$i_hosts];"    .
	    "export PAGER_EMAIL=$pager_email[$i_hosts];"    .
	    "export PATH=\$PATH:$orahome[$i_hosts]/bin;";
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "remsh";
          ##print "cmdpfx[$i_hosts]=$cmdpfx[$i_hosts]\n";
	}

        #---- Set probe path 
        $probe[$i_hosts] = "$probe_dir[$i_hosts]/dbamon_ora.pl"; 
        $instance[$i_hosts] = $orasid[$i_hosts]; 
      }

      if ($dbms[$i_hosts] eq "OracleApps")
      {
	if ($comm_method[$i_hosts] eq "ssh")
	{
	  $cmdpfx[$i_hosts]="ssh $hostname[$i_hosts] $tuserid " . 
	    "'export ORACLE_HOME=$orahome[$i_hosts] " .
	    ";export ORACLE_SID=$orasid[$i_hosts] " .
	    ";export PATH=\$PATH:$orahome[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "ssh";
	}
	else
	{
	  $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid " .
	    "'export ORACLE_HOME=$orahome[$i_hosts] " .
	    ";export ORACLE_SID=$orasid[$i_hosts] " .
	    ";export PATH=\$PATH:$orahome[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "remsh";
	}

        #---- Set probe path 
        $instance[$i_hosts] = $orasid[$i_hosts]; 
        $probe[$i_hosts] = "$probe_dir[$i_hosts]/dbamon_oraap.pl"; 
      }

      #---- OSWiin
      if ($dbms[$i_hosts] eq "OSWin")
      {
        if    ($ssh_port[$i_hosts]) { $ssh_port_string = " -p $ssh_port[$i_hosts] "; }
        else                        { $ssh_port_string = " "; }

        $cmdpfx[$i_hosts]="ssh $ssh_port_string $tuserid $hostname[$i_hosts] 'export MSSQL_INSTANCE=$mssql_instance[$i_hosts];" ;
        $cmdsfx[$i_hosts]="'";
        $remshcmd[$i_hosts] = "ssh";

        $probe[$i_hosts] = "dbamon_oswin.pl";
	$perlpath[$i_hosts] =~ s/\\/\//g;
        $instance[$i_hosts] = "OS"; 
      }

      #---- MSSQL
      if ($dbms[$i_hosts] eq "MSSQL")
      {
	if ($comm_method[$i_hosts] eq "ssh")
	{
          if    ($ssh_port[$i_hosts]) { $ssh_port_string = " -p $ssh_port[$i_hosts] "; }
          else                        { $ssh_port_string = " "; }

          if ($mssql_instance[$i_hosts])
          { 
	    $cmdpfx[$i_hosts]="ssh $ssh_port_string $tuserid $hostname[$i_hosts] 'export MSSQL_INSTANCE=$mssql_instance[$i_hosts];" ;
          }
          else
          {
	    $cmdpfx[$i_hosts]="ssh $ssh_port_string $tuserid $hostname[$i_hosts] '" ;
          }
   
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "ssh";

	  #$probe[$i_hosts] = "\\\\temp\\\\dbamon_mssql.pl";
	  ###$probe[$i_hosts] = "/cygwin/tmp/dbamon_mssql.pl";

	  $probe[$i_hosts] = "/tmp/dbamon_mssql.pl";
        
	  ##print "b4 $perlpath[$i_hosts] - $hostname[$i_hosts]\n";
	  $perlpath[$i_hosts] =~ s/\\/\//g;
	  ##print "af $perlpath[$i_hosts] - $hostname[$i_hosts]\n";
        }
	else
	{
	  $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid '" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "remsh";
          $probe[$i_hosts] = "\\temp\\dbamon_mssql.pl";
        }
        #--- OLD $instance[$i_hosts] = "MSSQL"; 
        $instance[$i_hosts] = $mssql_instance[$i_hosts]; 
      }

      ##print "cmdpfx=$cmdpfx[$i_hosts]\n";

      if ($dbms[$i_hosts] eq "OracleNT")
      {
	if ($comm_method[$i_hosts] eq "ssh")
	{
	  $cmdpfx[$i_hosts]="ssh $tuserid $hostname[$i_hosts] '" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "ssh";
	  ###$probe[$i_hosts] = "/cygwin/tmp/dbamon_orant.pl";
	  $probe[$i_hosts] = "/tmp/dbamon_orant.pl";
        
	  ##print "b4 $perlpath[$i_hosts] - $hostname[$i_hosts]\n";
	  $perlpath[$i_hosts] =~ s/\\/\//g;
	  ##print "af $perlpath[$i_hosts] - $hostname[$i_hosts]\n";
        }
	else
	{
	  $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid '" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "remsh";
	  $probe[$i_hosts] = "\\temp\\dbamon_orant.pl";
        }
        $instance[$i_hosts] = $orasid[$i_hosts]; 
      }

      ##print "parm remshcmd=" remshcmd[$i_hosts]

      if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] eq "" && $memwin[$i_hosts] ne "")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid \
	  'export INFORMIXDIR=$infdir[$i_hosts] \
	  ;export INFORMIXSERVER=$server[$i_hosts] \
	  ;export ONCONFIG=$config[$i_hosts] \
	  ;setmemwindow -i $memwin[$i_hosts] -p \$\$ \
	  ;$infdir[$i_hosts]/bin/";
	$cmdsfx[$i_hosts]="'";
      }

      if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] ne "" && $memwin[$i_hosts] ne "")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid \
	  'export INFORMIXDIR=$infdir[$i_hosts] \
	  ;export INFORMIXSERVER=$server[$i_hosts] \
	  ;export ONCONFIG=$config[$i_hosts] \
	  ;export INFORMIXSQLHOSTS=$sqlhosts[$i_hosts] \
	  ;setmemwindow -i $memwin[$i_hosts] -p \$\$ \
	  ;$infdir[$i_hosts]/bin/";
	$cmdsfx[$i_hosts]="'";
      }

    } # end of if dbcfile = ...

  } # end of DBCFILE foreach

  # Save number of highest host
  $high_host = $i_hosts;
  ##print "hh=$high_host ih=$i_hosts \n";

  if ($high_host == 0 || $high_host eq "")
  {
    &logit("0 Instances to monitor - Server Name Prefix for this task=$dbamon_alpha - Sleeping forever");
    sleep;
    exit 1;
  }

  # Re-process hosts entries to pad for title with longest length
  $spaces = "                                                    ";
  $i = 1;

  while ($i <= $high_host) 
  {
    &logit("  Including Instance: i=$i host=$hostname[$i] cm=$comm_method[$i] u=$userid[$i] dbms=$dbms[$i]");
    &logit("    dbcfile=$dbcfilename[$i] comm_method=$comm_method[$i] longest=$longest") if $debug_r;
    @words = split(/\./,$hostname[$i]);
    $hostname_first = $words[0];

    # BB Test to accomodate multiple processes writing to the same log
    $longest = 80;   #---- Changed from 30 - BB 2014/01/27

    $infname[$i] .= "_AppSrvr" if $what[$i] eq "AP";

    #---- Bug fix: we don't want to clear orahome every iteration, but it
    #----   can occur that if instances are renumbered, that this is set
    #----   for other DBMS's. So, clear this if the DBMS is not ^Oracle*
    $orahome[$i] = "" if $dbms[$i] !~ /^Oracle/;

    ###$title[$i] = substr("${hostname_first}:${infname[$i]}$spaces",0,$longest);

    #---- title will be the hostname first node + title1
    $title[$i] = substr("${hostname_first}_${infname[$i]}$spaces",0,$longest);

    # titleraw was added to have a way to grep for the host-instance
    # name in the dbspace history file to avoid duplicate entries
    # when the length of title shortens (bb 11Dec98)

    $hostfix[$i]   = $hostname_first;
    ###$titleraw[$i]  = "${hostname_first}:$infname[$i]";
    $titleraw[$i]  = "${hostname_first}_$infname[$i]";
    $titleraw_slash[$i]  = "${hostname_first}/$infname[$i]";
    $inhibfile[$i] = "${hostname_first}_$server[$i]";

    #---- This will be the instance identifier for history data - hostname first node + title1
    $titlehist[$i] = "${hostname_first}_" . uc $infname[$i];

    chop($fqhostname[$i] = `nslookup $hostname[$i] | grep 'Name:' | awk '{ print \$2 }'`)  if -e '/etc/resolv.conf' || $g_use_dns eq "Y";

    #---- Save this for later
    $probeout_file[$i] = "$tmpdir/probeout/${titleraw[$i]}.txt";

    #---- 20110523 BB - What? This next line doesn't make sense
    $fqhostname = $hostfix if ! $fqhostname;

    if($fqhostname[$i] eq "") 
    { 
      $domain_fiction = "nodomain.com"; 
      $fqhostname[$i] = "$hostname[$i].$domain_fiction"; 
      $serverloc[$i]  = "$domain_fiction"; 
    }

    if ($use_cmdb)
    {
      #---- Try to populate id8
      &sumCMDBSelect("$fqhostname[$i]");
      if ($star_class && $id8[$i] eq "")
      {
	$id8[$i] = $star_pri;
      }

      #---- Try to obtain CMDB contacts
      &readCMDBContacts($i); 
    }

    #---- Get the network location for this host
    $z = index($fqhostname[$i], '.');
    $serverloc[$i] = substr($fqhostname[$i],$z+1);
    ##print "DEBUG fqhostname=$fqhostname[$i] serverloc=$serverloc[$i] z=$z\n";
    
    #---- This var will be used for the key of all-instances checks
    $hostname_userid[$i] = "$hostname[$i]_$userid[$i]";

    if ($pager_subject[$i] ne "" || $pager_email[$i] ne "") 
    { 
      $pager_flag[$i] = 1; 
    }
    else                                                
    { 
      $pager_flag[$i] = 0;
    }

    #---- if ID4 contains /platinum/i then turn on pager_flag
    if ($id4[$i] =~ /platinum/i || $dbc_parm[$i]{'sla'} =~ /platinum/i)
    { 
      $pager_email[$i] = "DUMMY"; 
      $pager_flag[$i]  = 1; 
    }

    #---- bb 17May00 3.23.A Backup-only monitoring implies MBUN
    ##print "runmon=" runmon[$i]
    if ($runmon[$i] eq "B") 
    {
      $t_mustbeup[$i] = "N";
      $t_diskwarn[$i] = 999;
      $t_diskcrit[$i] = 999;
      $msg = sprintf("Since Monitor: is B then Must_Be_Up: Set to N and Full Thresholds set to 999 - %s",$title[$i]);
      logit($msg);
    }

    #---- Set URL for snapshot reports
    $ss_url[$i] = "<a HREF='$g_www_url/cgi-bin/dbamon_snapshots.pl?$mode,$titleraw[$i]'><b>Instance $titleraw[$i] Snapshot Reports</b></a>";

    #---- Instance log
    mkdir "/opt/dbamon/log/instances" if ! -e "/opt/dbamon/log/instances"; 
    $log_instance[$i] = "/opt/dbamon/log/instances/$titleraw[$i]";

    #---- SAVE LOG File - Start
    if ($dbms[$i] eq "Informix" || $dbms[$i] eq "Oracle") 
    {
      $save_file[$i] = "$save_dir/config.$hostname[$i]_$infname[$i]";
    }
    elsif ($dbms[$i] eq "MSSQL") 
    {
      $save_file[$i] = "$save_dir/Config_$titleraw[$i].txt";
    }
    else
    {
      $save_file[$i] = ""; 
    }

    #---- See if another instance is using THE SAME save_file
    &logit("  This instance CONFIG SAVE file: $save_file[$i]") if $debug_r;
    if ($save_file[$i] ne "") 
    {
      $this_save_file = $save_file[$i]; 
      if ($track_save_files{$this_save_file} == 1)
      {
        ##&error_fatal("Something is wrong! - save_file=$save_file[$i] is already being used by another instance"); 
      }
      $track_save_files{$this_save_file} = 1;
    }

    $html_events[$i] = "$html_events_dir/${hostname_first}_$infname[$i].html.new";

    $html_events_perm[$i] = "$html_events_dir/${hostname_first}_$infname[$i].html";
    $html_events_flag[$i] = 0;

    if ($arg eq "test") { $z = "/opt/dbamon/htm/details_test/" }
    else                { $z = "/opt/dbamon/htm/details/" }

    $html_details[$i]      = "${z}${hostname_first}_$infname[$i].html.new";
    $html_details_perm[$i] = "${z}${hostname_first}_$infname[$i].html";

    $html_details_flag[$i] = 0;

    #---- Old
    ## system("mkdir $z 2>/dev/null");
    #---- Old
    mkdir "$z" if ! -e "$z"; 

    if ($arg eq "test") { $z = "/dbamon/details_test/" }
    else                { $z = "/dbamon/details/" }
    $html_details_url[$i] = "${z}${hostname_first}_$infname[$i].html";

    if ($dbms[$i] eq "SAP") 
    {
      $dbmsout[$i] = "SAP";
      $dbms_color[$i] = "violet";
    }
    if ($dbms[$i] eq "Informix") 
    {
      $dbmsout[$i] = "Informix-UX";
      $dbms_color[$i] = "darkblue";
    }
    if ($dbms[$i] eq "Oracle")     
    {
      $dbmsout[$i] = "OracleDB-UX";
      $dbms_color[$i] = "red";
      &error_msg("Configuration Error: ORACLE_SID Cannot Be Null - Host: $hostname[$i]",$i) 
        if $orasid[$i] eq "";
      &error_msg("Configuration Error: ORACLE_HOME Cannot Be Null - Host: $hostname[$i]",$i) 
        if $orahome[$i] eq "";
    }
    if ($dbms[$i] eq "OracleApps") 
    {
      $dbmsout[$i] = "OracleApps";
      $dbms_color[$i] = "darkred";
    }
    if ($dbms[$i] eq "OracleNT")   
    {
      $dbmsout[$i] = "OracleDB-NT";
      $dbms_color[$i] = "ff0090";
    }
    if ($dbms[$i] eq "MSSQL")      
    {
      $dbmsout[$i] = "MSSQL";
      $dbms_color[$i] = "green";
    }
    if ($dbms[$i] eq "OSWin")      
    {
      $dbmsout[$i] = "Windows";
      $dbms_color[$i] = "black";
    }

    # Start - Debug a problem
    ##print "readDBC() - m_critical=$m_critical[$i] title=$title[$i]\n";
    # End   - Debug a problem

    &debug($i,"id9[$i]=$id9[$i]");

    # If there were any parm errors, create an event now
    if ($parm_errors[$i] ne "")
    {
      open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
      print TMPFL6 $parm_errors[$i];
      close(TMPFL6);
      &event("C",$i,"Error(s) Found in DBC File: $dbcfilename[$i]","DBCErr","DBA020",$tmpfl6);
      &logit("Error(s) Found in DBC File: $dbcfilename[$i]");
    }

    if ($dbms[$i] eq "MSSQL")      
    {
      &logDetails($i,"<span style='font-family:$www_font;font-size:10pt;'> <h3>Drill-Down Sections For This Instance: </h3>
        <table border=0 bgcolor=$table_bgcolor>
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#readDBCFile'><b>DBAmon Settings</b></a>  <td>$f_s  DBC Settings, etc. 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlUpSERVER'><b>Server/OS Information</b></a>  <td>$f_s  OS Level, Uptime, etc.  
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlUpDRIVE'><b>Server Disk Drive Information</b></a>  <td>$f_s  Server Disk Status 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlUpDBS'><b>MSSQL Databases</b></a>  <td>$f_s  DBs Within this Instance
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlUpINSTANCE'><b>MSSQL Instance Information</b></a>  <td>$f_s  MSSQL Version, Uptime, etc. 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlUpFILEPERF'><b>MSSQL DB File Performance Information</b></a>  <td>$f_s  I/O By DB, File.
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlUpREPL'><b>MSSQL Replication Performance</b></a>  <td>$f_s If Any - On Replication Distributors only
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlUpAO'><b>MSSQL AlwaysOn Status</b></a>  <td>$f_s If Any  
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlUpSSRSLog'><b>MSSQL SSRS ExecutionLog2 </b></a>  <td>$f_s If Any  
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlUpTRANS'><b>MSSQL Active Transactions </b></a>  <td>$f_s If Any - All Active Transaction (With TLOG Data &gt; 0) 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlTLog'><b>MSSQL TLOG Status</b></a>  <td>$f_s  TLOG Fullness, Filenames, etc.
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlBkup'><b>MSSQL DB Backups</b></a>  <td>$f_s  MSSQL DB Backup Age, Details, etc.
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlBkupTLOG'><b>MSSQL TLOG Backups</b></a>  <td>$f_s  MSSQL TLOG Backup Age, Details, etc. 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlAlerts'><b>MSSQL SQL Log and Agent Log (Current)</b></a>  <td>$f_s  Most Recent SQL and Agent Log Messages 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlFG'><b>MSSQL Filegroups - Size vs. Max Size</b></a>  <td>$f_s  MSSQL Filegroups by DB
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlFG'><b>MSSQL Filegroups - Drive Growth Potential </b></a>  <td>$f_s  Verifying DB File Growth Settings vs. Current Drive Capacity
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlPerf'><b>MSSQL Performance Data </b></a>  <td>$f_s  Performance Metrics with Chart URLs, etc.  
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlJobs'><b>MSSQL Jobs </b></a>  <td>$f_s  Status of all MSSQL Jobs
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#sqlTrends'><b>MSSQL Trend Readings </b></a>  <td>$f_s  Recent values vs. Historical values 
        </table> 
      "); 
      &logDetails($i,"<p><hr>");
    }
    elsif ($dbms[$i] eq "OSWin")      
    {
      &logDetails($i,"<span style='font-family:$www_font;font-size:10pt;'> <h3>Drill-Down Sections For This Instance: </h3>
        <table border=0 bgcolor=$table_bgcolor>
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#readDBCFile'><b>DBAmon Settings</b></a>  <td>$f_s  DBC Settings, etc. 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#osWinUpSERVER'><b>Server/OS Information</b></a>  <td>$f_s  OS Level, Uptime, etc.  
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#osWinUpDRIVE'><b>Server Disk Drive Information</b></a>  <td>$f_s  Server Disk Status 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#osWinPerf'><b>MSSQL Performance Data </b></a>  <td>$f_s  Performance Metrics with Chart URLs, etc.  
        </table> 
      "); 
      &logDetails($i,"<p><hr>");
    }
    elsif ($dbms[$i] eq "OracleNT")      
    {
      &logDetails($i,"<span style='font-family:$www_font;font-size:10pt;'> <h3>Drill-Down Sections For This Oracle/NT Instance: </h3>
        <table border=0 bgcolor=$table_bgcolor>
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#readDBCFile'><b>DBAmon Settings</b></a>  <td>$f_s  DBC Settings, etc. 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#orantUpINSTANCE'><b>Oracle/NT Instance Information</b></a>  <td>$f_s  Oracle Version, Uptime, etc. 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#orantUpSERVER'><b>Server/OS Information</b></a>  <td>$f_s  OS Level, Uptime, etc.  
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#orantUpDRIVE'><b>Server Disk Drive Information</b></a>  <td>$f_s  Server Disk Status 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#orantAlerts'><b>Oracle Alert Log (Current)</b></a>  <td>$f_s  Most Recent Alert Log Messages 
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#orantPerf'><b>Oracle/NT and Server Performance Data </b></a>  <td>$f_s  Performance Metrics with Chart URLs, etc.  
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#orantTS'><b>Oracle/NT Tablespaces </b></a>  <td>$f_s  Performance Metrics with Chart URLs, etc.  
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#orantTLog'><b>Oracle/NT Archive Log Status</b></a>  <td>$f_s  Drive, etc.
        <tr bgcolor=$table_rowcolor><td>$f_s <a href='#orantBkup'><b>Oracle DB Backups</b></a>  <td>$f_s  Oracle DB Backup Age, Details, etc.
        </table> 
      "); 
      &logDetails($i,"<p><hr>");
    }

    &logDetails($i,"<br><a name='readDBCFile'> <h3>DBAmon Settings For This Instance</h3>");
    &logDetails($i,"<table border=0 bgcolor=$table_bgcolor>");
    &logDetails($i,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Host:<td>$f_s $hostname[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>MSSQL_Instance:<td>$f_s $mssql_instance[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Fully Qualified Host:<td>$f_s $fqhostname[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>DBC File:<td>$f_s $dbcfilename[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Title:<td>$f_s $titleraw[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Comm_Method:<td>$f_s $comm_method[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Probe Path:<td>$f_s $probe[$i] <td>$f_s (May be changed later)");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Probe Dir:<td>$f_s $probe_dir[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Userid:<td>$f_s $userid[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Monitor:<td>$f_s $runmon[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Pager_Flag:<td>$f_s $pager_flag[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Internal: mssql_log_min_sev:<td>$f_s $mssql_log_min_sev[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Internal: dbc_udm_stringcheck:<td>$f_s $dbc_udm_stringcheck[$i]");
    &logDetails($i,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Internal: probeout_file:<td>$f_s $probeout_file[$i]");
    &logDetails($i,"</table>");

    &logDetails($i,"<br><h3>DBAmon DBC File: $dbcfilename[$i] </h3>");
    &logDetails($i,"<table border=0 bgcolor=$table_bgcolor>");
    &logDetails($i,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
    &logDetails($i, "$logdetails_dbc[$i]");
    &logDetails($i,"</table><hr>");

    #---- Set other flags
    if ($orasid[$i] =~ /^\+ASM/)
    {
      $asmflag[$i] = 1;
    }
    else
    {
      $asmflag[$i] = 0;
    }

    $i++;
  }

  # Wrapup
  ##$msg = sprintf("Read %s Host: definitions - longest title=%s",$high_host,$longest);
  &logit("$high_host Instance(s) Will Be Monitored By This Task");

  $dbmslist = "";
  ##print "num_informix=$num_informix \n";
  if ($num_oracleapps   > 0) { $dbmslist .= "OracleApps,"; }
  if ($num_oracle       > 0) { $dbmslist .= "OracleDB,"; }
  if ($num_informix     > 0) { $dbmslist .= "Informix,"; }
  if ($num_mssql        > 0) { $dbmslist .= "MSSQL,"; }
  if ($num_oraclent     > 0) { $dbmslist .= "OracleNT,"; }
  if ($num_sap          > 0) { $dbmslist .= "SAP,"; }
  if ($num_oswin        > 0) { $dbmslist .= "OSWin,"; }
  &logit("DBMS(s)/Appl(s) That Will Be Monitored: $dbmslist");

  # Write to task table
  ##if ($use_oracle eq "Y")
  ##{
  #---- We now ALWAYS use a repository
  if ($dbamon_alpha eq "") { $z = "*" }
  else                     { $z = $dbamon_alpha }
  $statement  = "delete from dbamon.task where dbamonmode = '$modeout' and iter_num = '0'";
  &runSQL($statement);
  $statement  = "
    insert into dbamon.task
    (dbamonmode,pid,starttime_num,starttime_char,alpha,iter_num,iter_dur,num_instances)
    values
    (\'$modeout\',\'$pid\', \'$time_processes\', \'$ts_processes\', \'$z\', \'0\',\'0\',\'$high_host\') ";
  runSQL($statement);
  #---- Nullify html_sys_path
  $html_sys_path = "/dev/null";
  ##}


  # Start - Debug a problem
  ##print "readDBC() - num_oracle=$num_oracle\n";
  # End   - Debug a problem

  #---- Read distlist data from repository
  # Moved this to dbamonMain - 2011/12/16 BB
  # &readDist;

  #---- Read debug data from repository
  &readDebug;

  #---- Read SWVer data from repository
  &readSWVer;

  $readdbc_elapsed = time - $readdbc_stime;
  &logit("readDBCFile - Duration: $readdbc_elapsed Seconds");
}

# -----------------------------------------------------------------------------
1;
